import cv2 as cv
import numpy as np
import copy
from matplotlib import pyplot as plt 

import pandas as pd
#读取工作簿和工作簿中的工作表
data_frame=pd.read_excel('../data/roi_point_2.xls'
                          ,sheet_name='Sheet1')

E_max = data_frame[2].to_list()
E_max = np.array(E_max)
print(E_max[0:5])
print(min(E_max))
print(max(E_max))
print(int(min(E_max)))
print(int(max(E_max))+1)

def otsu_binarization(E_max):
    max_sigma = 0
    max_t = 0
    th_min = int(min(E_max))
    th_max = int(max(E_max))+1
    for _t in np.arange(th_min, th_max, 0.01):
        v0 = E_max[np.where(E_max < _t)]
        m0 = np.mean(v0) if len(v0) > 0 else 0.
        w0 = len(v0) / len(E_max)
        v1 = E_max[np.where(E_max >= _t)]
        m1 = np.mean(v1) if len(v1) > 0 else 0.
        w1 = len(v1) / len(E_max)
        sigma = w0 * w1 * ((m0 - m1) ** 2)

        if sigma > max_sigma:
            max_sigma = sigma
            max_t = _t

    # Binarization
    print("threshold >>", max_t)
    return max_t

print(otsu_binarization(E_max))

'''




'''